import java.io.PrintStream;
import java.util.Date;

import type.lib.CreditCard;
import type.lib.RewardCard;

/**
 * @author mb
 * 
 */
public class L08App01 {

	public static void main(String[] args) {

		PrintStream output = System.out;
		CreditCard c1;
		c1 = new RewardCard(112234, "Tim Duncan", 6000);

		c1.charge(1000);
		output.println(c1.toString());

		/*
		 * take home point: early binding resolves c1 to CreditCard, which is
		 * its declared type. The compiler resolves the method charge(double) to
		 * CreditCard's version. Also, it resolves the method toString() to
		 * CreditCard's version.
		 * 
		 * At run-time, during late-binding, the VM resolves c1 to a RewardCard
		 * object. Thus, the compiler looks in the class definition of
		 * RewardCard for the method charge(double) and finds it (the overridden
		 * version of CreditCard's charge(double) method). Also, it looks in the
		 * class definition of RewardCard for the method toString() and finds it
		 * (the overridden version of CreditCard's toString() method).
		 * 
		 * So late binding resolved to a different referent than early binding.
		 */

		/*
		 * Is there an accessor that will tell us the type of an object at
		 * run-time?
		 */

		// output.println(c1.getClass());

	}
}
