import java.io.PrintStream;
import java.util.Date;

import type.lib.CreditCard;
import type.lib.RewardCard;

/**
 * @author mb
 * 
 */
public class L08App03 {

	public static void main(String[] args) {

		PrintStream output = System.out;
		CreditCard c1;
		RewardCard c2;

		c1 = new CreditCard(112233, "Charles Oakley", 5000);
		c2 = new RewardCard(112234, "Tim Duncan", 6000);

		output.println(c1.toString());
		output.println(c2.toString());

		/*
		 * A credit card object is considered similar to another one if it has
		 * the same balance, to the nearest cent, as the other, regardless of
		 * card number. Even if the two cards have different numbers, this
		 * method considers them similar as long as the difference between their
		 * balances is less than 0.01.
		 */
		output.println(c1.isSimilar(c2));

		/*
		 * take-home point: early binding looks at the declared type of c1,
		 * which is CreditCard. The signature is isSimilar(RewardCard). Can a
		 * target for this signature be found in CreditCard? yes, with promotion
		 * of c2 to CreditCard, there is a matching method
		 * isSimilar(CreditCard). For the purposes of the isSimilar method, c2
		 * is considered only as a credit card and its reward card aspects are
		 * simply ignored.
		 */

	}
}
