import java.io.PrintStream;
import java.util.Date;

import type.lib.CreditCard;
import type.lib.RewardCard;

/**
 * @author mb
 * 
 */
public class L08App05 {

	public static void main(String[] args) {

		PrintStream output = System.out;
		CreditCard c1, c2;

		c1 = new RewardCard(112233, "Charles Oakley", 5000);
		c2 = new RewardCard(112234, "Tim Duncan", 6000);

		c2.charge(1000);
		c2.pay(1000);

		output.println(c1.toString());
		output.println(c2.toString());

		/*
		 * So now c1 and c2 have the same card balance, but different point
		 * balances. Which isSimilar method will be invoked? CreditCard's
		 * isSimilar(CreditCard) will return true, whereas RewardCard's
		 * isSimilar(RewardCard) method will return false.
		 */		
			
		output.println(c1.isSimilar(c2));

		/*
		 * Take home point: the signature of an invoked method is determined at
		 * compiler time, during early binding. The signature at compile time is
		 * isSimilar(CreditCard). Here, the *actual* type of the parameter at
		 * run time is something different that the declared type of the
		 * parameter. The declared type of the parameter c2 is CreditCard, but
		 * at runtime the actual type of c2 is RewardCard. However, this does
		 * not matter in terms of program function. The VM invokes the inherited
		 * method isSimilar(CreditCard) and not the new method
		 * isSimilar(RewardCard). c2 is effectively promoted to a CreditCard for
		 * the isSimilar method.
		 */

	}
}
